<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLimitationConsumptionItem ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfLimitationConsumptionItem
 * @subpackage Arrays
 */
class ArrayOfLimitationConsumptionItem extends AbstractStructArrayBase
{
    /**
     * The LimitationConsumptionItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\LimitationConsumptionItem[]
     */
    public $LimitationConsumptionItem;
    /**
     * Constructor method for ArrayOfLimitationConsumptionItem
     * @uses ArrayOfLimitationConsumptionItem::setLimitationConsumptionItem()
     * @param \patest\StructType\LimitationConsumptionItem[] $limitationConsumptionItem
     */
    public function __construct(array $limitationConsumptionItem = array())
    {
        $this
            ->setLimitationConsumptionItem($limitationConsumptionItem);
    }
    /**
     * Get LimitationConsumptionItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\LimitationConsumptionItem[]|null
     */
    public function getLimitationConsumptionItem()
    {
        return isset($this->LimitationConsumptionItem) ? $this->LimitationConsumptionItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setLimitationConsumptionItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLimitationConsumptionItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLimitationConsumptionItemForArrayConstraintsFromSetLimitationConsumptionItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfLimitationConsumptionItemLimitationConsumptionItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfLimitationConsumptionItemLimitationConsumptionItemItem instanceof \patest\StructType\LimitationConsumptionItem) {
                $invalidValues[] = is_object($arrayOfLimitationConsumptionItemLimitationConsumptionItemItem) ? get_class($arrayOfLimitationConsumptionItemLimitationConsumptionItemItem) : sprintf('%s(%s)', gettype($arrayOfLimitationConsumptionItemLimitationConsumptionItemItem), var_export($arrayOfLimitationConsumptionItemLimitationConsumptionItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The LimitationConsumptionItem property can only contain items of type \patest\StructType\LimitationConsumptionItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set LimitationConsumptionItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\LimitationConsumptionItem[] $limitationConsumptionItem
     * @return \patest\ArrayType\ArrayOfLimitationConsumptionItem
     */
    public function setLimitationConsumptionItem(array $limitationConsumptionItem = array())
    {
        // validation for constraint: array
        if ('' !== ($limitationConsumptionItemArrayErrorMessage = self::validateLimitationConsumptionItemForArrayConstraintsFromSetLimitationConsumptionItem($limitationConsumptionItem))) {
            throw new \InvalidArgumentException($limitationConsumptionItemArrayErrorMessage, __LINE__);
        }
        if (is_null($limitationConsumptionItem) || (is_array($limitationConsumptionItem) && empty($limitationConsumptionItem))) {
            unset($this->LimitationConsumptionItem);
        } else {
            $this->LimitationConsumptionItem = $limitationConsumptionItem;
        }
        return $this;
    }
    /**
     * Add item to LimitationConsumptionItem value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\LimitationConsumptionItem $item
     * @return \patest\ArrayType\ArrayOfLimitationConsumptionItem
     */
    public function addToLimitationConsumptionItem(\patest\StructType\LimitationConsumptionItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\LimitationConsumptionItem) {
            throw new \InvalidArgumentException(sprintf('The LimitationConsumptionItem property can only contain items of type \patest\StructType\LimitationConsumptionItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->LimitationConsumptionItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\LimitationConsumptionItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\LimitationConsumptionItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\LimitationConsumptionItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\LimitationConsumptionItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\LimitationConsumptionItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string LimitationConsumptionItem
     */
    public function getAttributeName()
    {
        return 'LimitationConsumptionItem';
    }
}
